unit lt2n_arrays_codes_simplest_u1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls;

const kVers='15 Nov 18, 23:00- basis for distro';
  kMaxChars=255;

type

  { Tlt2n_arrays_codes_simplest_f1 }

  Tlt2n_arrays_codes_simplest_f1 = class(TForm)
    buEncrypt: TButton;
    ePlainText: TEdit;
    eEncryptedVersion: TEdit;
    procedure buEncryptClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
    chEncryptsAs:array [0..kMaxChars] of char;
    chTmp:char;
    sPlaintext,sEncrypt,sAllowedCharacters:AnsiString;

  public
    { public declarations }
  end;

var
  lt2n_arrays_codes_simplest_f1:
      Tlt2n_arrays_codes_simplest_f1;

implementation

{$R *.lfm}

{ Tlt2n_arrays_codes_simplest_f1 }

procedure Tlt2n_arrays_codes_simplest_f1.
   FormCreate(Sender: TObject);
var iTmp:integer;//Must be type integer
  //to accomodate 256 characters to be
  //allowed by the encrypting scheme,
  //because the string holding the
  //allowed characters is numbered
  //from "1".

begin
  application.title:='SimpleCode';
  lt2n_arrays_codes_simplest_f1.
    caption:='Simple Code, vers '+kVers;

  sAllowedCharacters:='ABCDEFG'+
    'HIJKLMNOPQRST'+
    'UVWXYZ ';// (Note the space at
    //the end... it's there so
    //that "space" can be encrypted,
    //sent with the message)

  //Fill the "chEncrptsAs" array...
  //  initially with the characters
  //  in the set of allowed characters
  //Like this, A "encrypts" to A, B to B
  //  and so on. But we will "fix" that,
  //  later!

  for iTmp:=1 to length(sAllowedCharacters)
    do begin
       chEncryptsAs[iTmp-1]:=
          sAllowedCharacters[iTmp];
    end;//for...

  //But we are going to change what's in
  //that table now...
  //Start by storing the first element of
  //  the array chEncryptsAs[], temporarily...
  chTmp:=chEncryptsAs[0];

  //Now overwrite the first element with the
  //second, the second with the 3rd, etc,
  //all the way to the last-but-one...
  iTmp:=length(sAllowedCharacters);
  for iTmp:=0 to length(sAllowedCharacters)-2
    do begin
     chEncryptsAs[iTmp]:=chEncryptsAs[iTmp+1];;
    end;//for...
  //chEncryptsAs[sAllowedCharacters-1] is the
  //LAST element of the array, remember.
  //--
  //Now fill the last element with what WAS in
  //the first element, before you shifted everything
  //along!...
  chEncryptsAs[length(sAllowedCharacters)-1]:=chTmp;
end;//FormCreate

procedure Tlt2n_arrays_codes_simplest_f1.
   buEncryptClick(Sender: TObject);
var iLetter,iLast:integer;
  iPosnInAllowedChars:integer;//Even
    //though this is designed "only"
    //to be able to encrypt 256 characters,
    //iPosnInAllowedChars may be 256 in
    //a special case. It would happen from
    //iPosnInAllowedChars:=
    //     pos(chTmp,sAllowedCharacters);
    //when chTmp were whatever the
    //  last allowed character was, as
    //  defined in sAllowedCharacters.
    //So: iPosnInAllowedChars must be
    //  of type "integer", even though
    //  //almost// all of the time,
    //  "byte" would be good enough.
begin
   sPlainText:=ePlainText.text;
   iLast:=length(sPlainText);
   //If sPlainText is "ABC",
   //   length(sPlainText) will be 3.
   sEncrypt:='';
   for iLetter:=1 to iLast do begin
      chTmp:=sPlaintext[iLetter];
      //if sPlainText is "ABC",
      //sPlaintext[1] will be "A"
      iPosnInAllowedChars:=
         pos(chTmp,sAllowedCharacters);
      //If you say pos('A','ABC'), you get ** 1 **
      //If you say pos('x','ABC'), you get ZERO.
      //Apart from anything else, pos needs a
      //  way to say "couldn't find it.")
      if (iPosnInAllowedChars<>0) then begin
         sEncrypt:=
           sEncrypt+
             chEncryptsAs[iPosnInAllowedChars-1];
         end//no ; here
        else begin
         sEncrypt:=sEncrypt+chTmp;//Characters
           //not provided for in
           //sAllowedCharacters go
           //through untouched.
        end;//of else of if.
   end;//for...
   eEncryptedVersion.text:=sEncrypt;
  end;//buEncryptClick

end.

